//+-------------------------------------------------------------------------------+ 
//|                                                           3c_AllFibpivots.mq4 |
//|                                                     http://www.forex-tsd.com  |
//|                                                                               |
//|                                                                               |
//| You are NOT ALLOWED to distribute this EA in any public forum                 |
//| Property of  http://www.forex-tsd.com ELITE section ONLY                      |
//+-------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#include <stdlib.mqh>
#include <stderror.mqh>
#define  PAUSE_BEFORE_RETRY 500

//
//
//
//
//

extern int     MagicNumber            = 998877;
extern bool    EcnBroker              = false;
extern bool    NoHedge                = false;
extern bool    UseAutomaticMM         = true;
extern double  Risk                   = 2.50;
extern double  BaseLot                = 0.1;
extern bool    CloseOnTrendChange     = false;

extern string  _                      = "Range settings";
extern double  Range.stopLoss         = 0.75;
extern double  Range.takeProfit       = 4.0;
extern double  Range.trailingStop     = 0.4;
extern double  Range.lockProfit       = 0.4;
extern int     Range.timeFrame        = PERIOD_D1;
extern int     Range.length           = 20;
extern int     shift                  = 1;			//shift to current bar, 

extern string  __                     = "Indicators settings";
extern string  hlcj                   = "HighLow channel smooth daily for trend";
extern int     SmoothPeriod           = 10;
extern int     SmoothPhase            = 0;
extern int     trendtf                = 15;

extern string  ___DZ                  = "D Z Stochastic settings";
extern int     StoKPeriod             = 5;
extern int     StoDPeriod             = 3;
extern int     StoSlowingPeriod       = 3;
extern int     StoMaMethod            = MODE_LWMA;
extern int     StoPrice               = 0;
extern int     DzLookBackBars         = 70;
extern double  DzStartBuyProbability  = 0.10;
extern double  DzStartSellProbability = 0.10;

extern string  xy                     = "Special Settings"; 
extern bool    Usefibpivots           = true; //if true will be using reg third candle trend  with fibpivote
extern bool    Usetrend               = false;  //if true third candle trend but with fractal dimension Ehlers and hl jurik channel
                                               //if both = false will be trading regular third candle trend 
			
extern string  FiboPivotSetting       = "FiboPivotLineSettings";
extern bool    Showfibpivots          = true;  // this you should be able to use whatever method you use but will be for reference only unless using fibs      
extern color   Resistance_3           = Magenta;
extern color   Resistance_2           = Red;
extern color   Resistance_1           = Red;
extern color   Pivot                  = Gold;
extern color   Support_1              = LimeGreen;
extern color   Support_2              = LimeGreen;
extern color   Support_3              = Aqua;
extern int     Pivottimeframe         = PERIOD_D1;

extern string  xx                     = "FDE Settings";
extern int     FDSize                 = 30;
extern int     FDPrice                = PRICE_MEDIAN;
extern double  FDTreshold             = 1.4;

extern string  ____TimeFilter         = "Time filter settings";
extern string  Trade.startFrom        = "00:00";
extern string  Trade.endAt            = "24:00";
extern bool    Trade.useServerTime    = true;
extern string  ___                    = "";
extern int     AllowedSlippage        =  0;
extern bool    showMessages           = false;

//
//
//
//
//

int    NumberOfTries = 5;
double pipMultiplier = 1;
double currentRange  = 0;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()   { 
      
return(0); }


int deinit() { 

    ObjectDelete("S1");
    ObjectDelete("S2");
    ObjectDelete("S3");
    ObjectDelete("SS");   
    ObjectDelete("R1");
    ObjectDelete("R2");
    ObjectDelete("R3");
    ObjectDelete("SR");    
    ObjectDelete("PIVOT");
    ObjectDelete("Support 1");
    ObjectDelete("Support 2");
    ObjectDelete("Support 3");
    ObjectDelete("Pivot level");
    ObjectDelete("Resistance 1");
    ObjectDelete("Resistance 2");
    ObjectDelete("Resistance 3");  
    ObjectDelete("TDR2");
    ObjectDelete("TDR2 Line"); 
    ObjectDelete("BDR2");
    ObjectDelete("BDR2 Line");    
    Comment(" "); 

return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define __trendUp       1
#define __trendDown    -1
#define __trendNeutral  0

//
//
//
//
//

int start()
{    
   if (!CheckTerminalStatus()) return(0);
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;               

   //
   //
   //
   //
   //
 
      currentRange = getRange(Range.timeFrame,Range.length);
      if (currentRange==0)
            { showTwoStateMessage("noDataForRange","not enough data for range",false); return(0); }
      else    showTwoStateMessage("noDataForRange","range OK"                 ,true);
      
      
      
   

   //
   //
   //
   //
   //
   
         int trendDirection = findTrend();  manageOpenedOrders(trendDirection);
         bool canEnterNewTrade = true;

   //
   //
   //    time fiter checking
   //
   //
      
         if (canEnterNewTrade)
         {
            string     st1 = normalizeTime(Trade.startFrom);
            string     et1 = normalizeTime(Trade.endAt);
            datetime   ts  = StrToTime(TimeToStr(Time[0],TIME_DATE)+st1);
            datetime   te  = StrToTime(TimeToStr(Time[0],TIME_DATE)+et1);
            if (te<ts) te -= 24*60*60;
            canEnterNewTrade = ((Time[0]>=ts && Time[0]<=te));
          } 

   //
   //
   //
   //
   //
   
   if (canEnterNewTrade && trendDirection != __trendNeutral)
   {
   if (countClosedOrders()>0) return(0);}
      
   
      
   //
   //
   //
   //
   //

   int openedBuys=0;
   int openedSells=0;
   if (countOpenedOrders(openedBuys,openedSells)==0)
   {
      double tradeLots = getLots(currentRange);
         if(AccountFreeMargin()<tradeLots*MarketInfo(Symbol(),MODE_MARGINREQUIRED))
            { showTwoStateMessage("money","Not enough money to trade "+DoubleToStr(tradeLots,2),false); return(0); }
         else showTwoStateMessage("money","Continuing to trade",true);
      
      //
      //
      //
      //
      //
      
      if (trendDirection==__trendUp   && openedSells==0) Buy(tradeLots);
      if (trendDirection==__trendDown && openedBuys ==0) Sell(tradeLots);
   }  
   return(0);      
}



//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//    lots and range calculation
//
//
//

double getLots(double range)
{
   RefreshRates();
   double step   = MarketInfo(Symbol(),MODE_LOTSTEP);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
      lots = AccountFreeMargin()*(Risk/100.0)/(range*Range.stopLoss*MarketInfo(Symbol(),MODE_TICKVALUE)/Point);
      }
   }      
   return(MathMax(MathMin(lots,maxLot),minLot));   
}

//
//
//
//
//

double getRange(int timeFrame,int length)
{
   static double   newRange = 0;
   static datetime newTime  = 0;
   static int      newBars  = 0;
   string symbol = Symbol();
   
 
   //
   //
   //
   //
   //
     
   if (newTime != iTime(symbol,timeFrame,0) || newBars != iBars(symbol,timeFrame))
   {
      newTime  = iTime(symbol,timeFrame,0);
      newBars  = iBars(symbol,timeFrame);
      newRange = 0;
   
      //
      //
      //
      //
      //
      
      int d = 0;
      for (int i=0;d<length;i++)
      {
         double high = iHigh(symbol,timeFrame,i+1);
         double low  = iLow (symbol,timeFrame,i+1);
         
         if (high==0 || low==0) break;
         if (TimeDayOfWeek(iTime(symbol,timeFrame,i+1))==0) continue;
      
         //
         //
         //
         //
         //
            
         newRange += (high-low); d++;
      }
      newRange /= (d+1.0);
   }      
   return(newRange);
}


//----------------------------------------------------------------------------------------
//       trend determination       
//----------------------------------------------------------------------------------------



int findTrend()
{
   RefreshRates();
   
   double sto1   = iCustom(NULL,0,"dynamic zone stochastic",StoKPeriod,StoDPeriod,StoSlowingPeriod,StoMaMethod,StoPrice,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,0,shift);
   double sto2   = iCustom(NULL,0,"dynamic zone stochastic",StoKPeriod,StoDPeriod,StoSlowingPeriod,StoMaMethod,StoPrice,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,0,shift+1);
   double stoos  = iCustom(NULL,0,"dynamic zone stochastic",StoKPeriod,StoDPeriod,StoSlowingPeriod,StoMaMethod,StoPrice,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,2,shift);
   double stoos1 = iCustom(NULL,0,"dynamic zone stochastic",StoKPeriod,StoDPeriod,StoSlowingPeriod,StoMaMethod,StoPrice,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,2,shift+1);
   double stoob  = iCustom(NULL,0,"dynamic zone stochastic",StoKPeriod,StoDPeriod,StoSlowingPeriod,StoMaMethod,StoPrice,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,3,shift);
   double stoob1 = iCustom(NULL,0,"dynamic zone stochastic",StoKPeriod,StoDPeriod,StoSlowingPeriod,StoMaMethod,StoPrice,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,3,shift+1);
   double val1   = iCustom(NULL,trendtf,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,0,shift);
   double val2   = iCustom(NULL,trendtf,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,1,shift);
   double val11  = iCustom(NULL,trendtf,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,0,shift+1);
   double val22  = iCustom(NULL,trendtf,"HiLow channel Jurik smooth",SmoothPeriod,SmoothPhase,1,shift+1);
   double fde    = iCustom(NULL,trendtf,"Fractal dimesion Ehlers",FDSize,FDPrice,FDTreshold,2,shift);
   double fde1   = iCustom(NULL,trendtf,"Fractal dimesion Ehlers",FDSize,FDPrice,FDTreshold,2,shift+1); 
   double fdetd  = iCustom(NULL,trendtf,"Fractal dimesion Ehlers",FDSize,FDPrice,FDTreshold,0,shift);
   double fdetd1 = iCustom(NULL,trendtf,"Fractal dimesion Ehlers",FDSize,FDPrice,FDTreshold,0,shift+1); 
   
   double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
   ArrayCopyRates(rates, Symbol(), Pivottimeframe);
   if(DayOfWeek() == 1)
   {
   if(TimeDayOfWeek(iTime(Symbol(),Pivottimeframe,1)) == 5)
   {
   yesterday_close = rates[1][4];
   yesterday_high = rates[1][3];
   yesterday_low = rates[1][2];
   }
   else
   {
   for(int d = 5;d>=0;d--)
   {
   if(TimeDayOfWeek(iTime(Symbol(),Pivottimeframe,d)) == 5)
   {
   yesterday_close = rates[d][4];
   yesterday_high = rates[d][3];
   yesterday_low = rates[d][2];
   }     
   }    
   }
   }
   else
   {
   yesterday_close = rates[1][4];
   yesterday_high = rates[1][3];
   yesterday_low = rates[1][2];
   }
   double R = yesterday_high - yesterday_low;//range
   double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
   double r3 = p + (R * 1.000);
   double r2 = p + (R * 0.618);
   double r1 = p + (R * 0.382);
   double s1 = p - (R * 0.382);
   double s2 = p - (R * 0.618);
   double s3 = p - (R * 1.000);
   double day_high=0;
   double day_low=0;
   double nQ=0;
   double nD=0;
   double D=0;
   double Q=0;
   day_high = rates[0][3];
   day_low = rates[0][2];
   D = (day_high - day_low);
   Q = (yesterday_high - yesterday_low);
   double fb,fs,fe,tp1,tp2,tp3;
   double ri,re1,re2,re3,ra1,ra2,ra3;
   if (Q > 5) 
   {
	nQ = Q;
   }
   else
   {
	nQ = Q*10000;
   }

   if (D > 5)
   {
	nD = D;
   }
   else
   {
	nD = D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   nQ=nQ/100;
   nD=nD/100;     
   }
   if (Showfibpivots)
   {
   drawLine(r3,"R3", Resistance_3,1);
   drawLabel("Resistance 3",r3,Resistance_3);
   drawLine(r2,"R2", Resistance_2,2);
   drawLabel("Resistance 2",r2,Resistance_2);
   drawLine(r1,"R1", Resistance_1,0);
   drawLabel("Resistance 1",r1,Resistance_1);

   drawLine(p,"PIVOT",Pivot,1);
   drawLabel("Pivot level",p,Pivot);

   drawLine(s1,"S1",Support_1,0);
   drawLabel("Support 1",s1,Support_1);
   drawLine(s2,"S2",Support_2,2);
   drawLabel("Support 2",s2,Support_2);
   drawLine(s3,"S3",Support_3,1);
   drawLabel("Support 3",s3,Support_3);  
   } 
   
   if(Usefibpivots)
   {
   if(Low[3] > Low[2] && Low[2] < Low[1] && Open[0] > Open[1] && Close[3] < Open[3] && Close[1] > Open[1] && Close[2] > Open[2] &&  Bid <= s1 && Bid >= s3)    return(__trendUp);        
   if(High[3] < High[2] && High[2] > High[1] && Open[0] < Open[1] && Close[3] > Open[3] && Close[1] < Open[1] && Close[2] < Open[2] && Bid >= r1 && Bid <= r3) return(__trendDown);
                                                                                                                                                               return(__trendNeutral);
   }                                                                                                                                                              
   if(Usetrend)
   {
   if(Low[3] > Low[2] && Low[2] < Low[1] && Open[0] > Open[1] && Close[3] < Open[3] && Close[1] > Open[1] && Close[2] > Open[2] && sto1 >= stoos && sto2 < stoos1 && val1 < val2 && val2 > val22 && fde < fde1)     return(__trendUp);
   if(High[3] < High[2] && High[2] > High[1] && Open[0] < Open[1] && Close[3] > Open[3] && Close[1] < Open[1] && Close[2] < Open[2] && sto1 <= stoob && sto2 > stoob1 && val1 > val2 && val1 < val11 && fde < fde1) return(__trendDown);
                                                                                                                                                                                                                    return(__trendNeutral);
   }
   else 
   {
   if(Low[3] > Low[2] && Low[2] < Low[1] && Open[0] > Open[1] && Close[3] < Open[3] && Close[1] > Open[1] && Close[2] > Open[2] && sto1 >= stoos && sto2 < stoos1)     return(__trendUp);
   if(High[3] < High[2] && High[2] > High[1] && Open[0] < Open[1] && Close[3] > Open[3] && Close[1] < Open[1] && Close[2] < Open[2] && sto1 <= stoob && sto2 > stoob1) return(__trendDown);
                                                                                                                                                                       return(__trendNeutral);
}
}
   



//----------------------------------------------------------------------------------------
//       opened orders management 
//----------------------------------------------------------------------------------------
//
//
//
//
//

int countOpenedOrders(int& openedBuys,int& openedSells)
{
   int openedOrders=0;   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderSymbol() != Symbol()) continue;
      if(NoHedge)
      {
         if(OrderType() == OP_BUY)  openedBuys++;
         if(OrderType() == OP_SELL) openedSells++;
      }
      if(OrderMagicNumber() != MagicNumber) continue;
                  
      //
      //
      //
      //
      //
                  
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) openedOrders++;
   }      
   return(openedOrders);
}


int countClosedOrders()
{
   int      closedAtBar = 0;    
   datetime startTime   = Time[0];
   datetime endTime     = Time[0]+Period()*60;
   
   for(int i = OrdersHistoryTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == false) break;
      if(OrderMagicNumber() != MagicNumber)                       continue;
      if(OrderSymbol()      != Symbol())                          continue;
      if(OrderCloseTime()<startTime || OrderCloseTime()>=endTime) continue; 
         closedAtBar++;
         break;
   } 
   return(closedAtBar); 
}  

//
//
//
//
//

void manageOpenedOrders(int currentDirection)
{
   
   double StopLoss     = currentRange*Range.stopLoss;
   double TakeProfit   = currentRange*Range.takeProfit;
   double trailingStop = currentRange*Range.trailingStop;
   double lockProfit   = currentRange*Range.lockProfit;
   int    err,i,c;
   double newStop;
   double curStop;
   double minStop;
   
   //
   //
   //
   //
   //
   
   for(i=OrdersTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol()      != Symbol())    continue;

      //
      //
      //
      //
      //
      
      if(OrderType() == OP_BUY)
      {
         if (CloseOnTrendChange) { if (currentDirection==__trendDown) CloseOrder(0,OrderTicket()); continue; }
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(OrderTicket(),Ask+TakeProfit);}}
         if (EcnBroker && StopLoss > 0) { if (OrderStopLoss  ()==0) { RefreshRates(); setStopLoss  (OrderTicket(),Bid-StopLoss);}}
         //
         //
         //
         //
         //
         
         if (Range.trailingStop>0)
         {
            for(c=0; c<NumberOfTries; c++)
            { 
               RefreshRates();
                  curStop = NormalizeDouble(OrderStopLoss(),Digits);
                  newStop = NormalizeDouble(Bid-trailingStop,Digits);
                  minStop = NormalizeDouble(OrderOpenPrice()+lockProfit,Digits);
                  if (newStop>curStop && newStop>minStop)
                     {
                        OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                        
                        err = GetLastError(); checkError("stop loss modified",err);
                        switch (err)
	  	                  {
                        case ERR_SERVER_BUSY:
                        case ERR_NO_CONNECTION:
                        case ERR_INVALID_PRICE:
                        case ERR_OFF_QUOTES:
                        case ERR_BROKER_BUSY:
                        case ERR_TRADE_CONTEXT_BUSY:
			               Sleep(PAUSE_BEFORE_RETRY);
			               continue;

                        case ERR_PRICE_CHANGED:
			               case ERR_REQUOTE:
				            continue;

                        default:
	                     c=NumberOfTries;
	                     continue;
                     }
                 }
              }
          }
      }
      //
      //
      //
      //
      
      if(OrderType() == OP_SELL)
      {
         if (CloseOnTrendChange) { if (currentDirection==__trendUp) CloseOrder(0,OrderTicket()); continue; }
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(OrderTicket(),Bid-TakeProfit);}}
         if (EcnBroker && StopLoss > 0) { if (OrderStopLoss  ()==0) { RefreshRates(); setStopLoss  (OrderTicket(),Ask+StopLoss);}}

         //
         //
         //
         //
         //
         
         if (Range.trailingStop>0)
         {
            for(c=0; c<NumberOfTries; c++)
            { 
               RefreshRates();
                  curStop = NormalizeDouble(OrderStopLoss(),Digits);
                  newStop = NormalizeDouble(Ask+trailingStop,Digits);
                  minStop = NormalizeDouble(OrderOpenPrice()-lockProfit,Digits);
                  if (curStop>0 && newStop<curStop && newStop<minStop)
                  {
                  OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  
                  err = GetLastError(); checkError("stop loss modified",err);
                  switch (err)
	  	            {
                  case ERR_SERVER_BUSY:
                  case ERR_NO_CONNECTION:
                  case ERR_INVALID_PRICE:
                  case ERR_OFF_QUOTES:
                  case ERR_BROKER_BUSY:
                  case ERR_TRADE_CONTEXT_BUSY:
			         Sleep(PAUSE_BEFORE_RETRY);
			         continue;

                  case ERR_PRICE_CHANGED:
			         case ERR_REQUOTE:
				      continue;

                  default:
	               c=NumberOfTries;
	               continue;
	               }
                }
               } 
             }
       
          }
               
       }
     }




      

//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//
void setStopLoss(int ticket,double stopLoss)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),stopLoss,OrderTakeProfit(),0);
      int     err = GetLastError(); checkError("stop loss aplied",err);
      switch (err)
	  	{
      case ERR_SERVER_BUSY:
      case ERR_NO_CONNECTION:
      case ERR_INVALID_PRICE:
      case ERR_OFF_QUOTES:
      case ERR_BROKER_BUSY:
      case ERR_TRADE_CONTEXT_BUSY:
      Sleep(PAUSE_BEFORE_RETRY);
		continue;

      case ERR_PRICE_CHANGED:
		case ERR_REQUOTE:
		continue;

      default:
	   c=NumberOfTries;
	   continue;
     }
   }
}

//
//
//
//
//

void setTakeProfit(int ticket,double takeProfit)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),takeProfit,0);
      int     err = GetLastError(); checkError("take profit aplied",err);
      switch (err)
	  	{
      case ERR_SERVER_BUSY:
      case ERR_NO_CONNECTION:
      case ERR_INVALID_PRICE:
      case ERR_OFF_QUOTES:
      case ERR_BROKER_BUSY:
      case ERR_TRADE_CONTEXT_BUSY:
	   Sleep(PAUSE_BEFORE_RETRY);
		continue;

      case ERR_PRICE_CHANGED:
	   case ERR_REQUOTE:
		continue;

      default:
	   c=NumberOfTries;
	   continue;
     }
   }
}


//
//
//
//
//

void Buy(double Lots)
{ 
   double StopLoss   = currentRange*Range.stopLoss;
   double TakeProfit = currentRange*Range.takeProfit;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0; c<NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss>0)   sl = Bid-StopLoss;
            if (TakeProfit>0) tp = Ask+TakeProfit;
         }            
      
         int ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,AllowedSlippage*pipMultiplier,sl,tp,"3c - buy",MagicNumber,0,Blue);
         
         int     err = GetLastError(); checkError("buy order opened",err);
  			switch (err)
         {
         case ERR_NO_ERROR:
         if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Bid-StopLoss);
         if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Ask+TakeProfit);
         c=NumberOfTries;
         continue;
			                 
			case ERR_SERVER_BUSY:
         case ERR_NO_CONNECTION:
         case ERR_INVALID_PRICE:
         case ERR_OFF_QUOTES:
         case ERR_BROKER_BUSY:
         case ERR_TRADE_CONTEXT_BUSY:
         Sleep(PAUSE_BEFORE_RETRY);
         continue;

         case ERR_PRICE_CHANGED:
         case ERR_REQUOTE:
	      continue;

         default:
         c=NumberOfTries;
         continue;
       }
   } 	    
}

//
//
//
//
//

void Sell(double Lots)
{        
   double StopLoss   = currentRange*Range.stopLoss;
   double TakeProfit = currentRange*Range.takeProfit;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0;c <NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss>0)   sl = Ask+StopLoss;
            if (TakeProfit>0) tp = Bid-TakeProfit;
         }
      
         int ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,AllowedSlippage*pipMultiplier,sl,tp,"3c - sell",MagicNumber,0,Red);
         
         int     err = GetLastError(); checkError("sell order opened",err);
  			switch (err)
         {
         case ERR_NO_ERROR:
         if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Ask+StopLoss);
         if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Bid-TakeProfit);
         c=NumberOfTries;
         continue;
			                 
			case ERR_SERVER_BUSY:
         case ERR_NO_CONNECTION:
         case ERR_INVALID_PRICE:
         case ERR_OFF_QUOTES:
         case ERR_BROKER_BUSY:
         case ERR_TRADE_CONTEXT_BUSY:
         Sleep(PAUSE_BEFORE_RETRY);
         continue;

         case ERR_PRICE_CHANGED:
         case ERR_REQUOTE:
	      continue;

         default:
         c=NumberOfTries;
         continue;
       }
   }
}

//----------------------------------------------------------------------------------------
//       miscellaneus functions           
//----------------------------------------------------------------------------------------
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}



//----------------------------------------------------------------------------------------
//       orders closing and closing all (panic close)
//----------------------------------------------------------------------------------------
//
//
//
//
//

void CloseOrder(double lotsToClose=0,int ticket=-1)
{
   double minLot = NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);
   string message;

   //
   //
   //
   //
   //
      
   if (IsTesting() || CheckTradeAllowed())
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (OrderSymbol() != Symbol())       continue;
      if (ticket!=-1)
         if (OrderTicket()!=ticket) continue;
         
      //
      //
      //
      //
      //
         
      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         if (OrderType()==OP_BUY)
               { string operation = "buy"; color theColor  = Blue;}  
         else  {        operation = "sell";      theColor  = Red; }
            
         //
         //
         //
         //
         //

         if (lotsToClose==0) lotsToClose = OrderLots();
         if (lotsToClose!=OrderLots())
         {
            lotsToClose = MathMax(minLot,lotsToClose);
               if (OrderLots() < 2.0*minLot)
                  lotsToClose = OrderLots();
         }               
            
         if (lotsToClose!=OrderLots())
                  message="partialy closed "+operation+" - closed "+DoubleToStr(lotsToClose,2)+" lots";
         else     message=operation+" order closed";
            
         //
         //
         //
         //
         //
            
         for(int c=0 ; c<NumberOfTries; c++)
         {
            RefreshRates();
            if (OrderType()==OP_BUY)
                  double cp = Bid;  
            else         cp = Ask;
               
            //
            //
            //
            //
            //
               
            OrderClose(OrderTicket(),lotsToClose,cp,AllowedSlippage*pipMultiplier,theColor);
            
            int err=GetLastError();  checkError(message,err);
     			switch (err)
            {
    		  case ERR_SERVER_BUSY:
           case ERR_NO_CONNECTION:
           case ERR_INVALID_PRICE:
           case ERR_OFF_QUOTES:
           case ERR_BROKER_BUSY:
           case ERR_TRADE_CONTEXT_BUSY:
           Sleep(PAUSE_BEFORE_RETRY);
           continue;

           case ERR_PRICE_CHANGED:
           case ERR_REQUOTE:
    	     continue;

           default:
           c=NumberOfTries;
           continue;
          }
        }
     }            
   }  
}

//----------------------------------------------------------------------------------------
//       fib draw
//----------------------------------------------------------------------------------------

void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 8, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}
void drawLine(double lvl,string name, color Col,int type)
{
        if(ObjectFind(name) != 0)
        {
        ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
        if(type == 1)
        ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
        else if(type == 2)
        ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
        else
        ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);   
        ObjectSet(name, OBJPROP_COLOR, Col);
        ObjectSet(name,OBJPROP_WIDTH,1);
            
        }
        else
        {
        ObjectDelete(name);
        ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
        if(type == 1)
        ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
        else if(type == 2)
        ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
        else
        ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);   
        ObjectSet(name, OBJPROP_COLOR, Col);        
        ObjectSet(name,OBJPROP_WIDTH,1);
          
      }
}


//----------------------------------------------------------------------------------------
//       terminal status handling
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTradeAllowed() { return(IsTradeAllowed() && !IsStopped() && IsExpertEnabled() && !IsTradeContextBusy()); }
bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Reconected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started again",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed again",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled again",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready again",true);

      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   return(status);
}


//----------------------------------------------------------------------------------------
//       messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>=0; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = true;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   
   //
   //
   //
   //
   //
   
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}

